Notifications not sent when Quassel is minimized
Description
Using Quassel verion 0.9.0 on gentoo. Running KDE 4.10.5 at the moment.

When quassel is NOT minimized but it has no focus notifications are sent normally and | can see them in the KDE notification area.
But when quassell is minimized no notification is sent at all. This can be reproduced on Kubuntu 13.04 as well.

This issue might be related to #1179 .

Related issues:
Related to Quassel IRC - Bug #1179: KDE notifications not working Feedback 08/23/2012
Related to Quassel IRC - Bug #1231: New PMs from other users don't trigger no... Closed 06/14/2013

Associated revisions

Revision fd975193 - 12/18/2013 12:52 PM - Martin Sandsmark

Fix notifications when minimized.

QWidget::isVisible() just checks if the widget has been explicitly
hidden, not if it is minimized, covered, or whatnot.

Fixes #1240
Revision e5729ea1 - 12/23/2013 12:32 AM - Martin Sandsmark
Fix notifications when minimized.

QWidget::isVisible() just checks if the widget has been explicitly
hidden, not if it is minimized, covered, or whatnot.

Fixes #1240

History

#1 - 09/07/2013 07:35 PM - enrico.tagliavini

Possible important note: the quassel systray icon does NOT blink red when minimized as well, but works as expected when not minimized

#2 - 09/08/2013 04:11 AM - enrico.tagliavini

Possibly found something more:
In mainwin.cpp:

void MainWin::bufferViewToggled(bool enabled) {

gDebug() << "#i## called bufferViewToggled";

if (lenabled && lisVisible()) {

// hiding the mainwindow triggers a toggle of the bufferview (which pretty much sucks big time)
/I since this isn't our fault and we can't do anything about it, we suppress the resulting calls
return;

}

QAction *action = qobject_cast<QAction *>(sender());

Q_ASSERT (action);

BufferViewDock *dock = qobject_cast<BufferViewDock *>(action->parent());
Q_ASSERT(dock);

// Make sure we don't toggle backlog fetch for a view we've already removed
if (!_bufferViews.contains (dock))
return;

if (enabled)
Client::bufferViewOverlay () —>addView (dock->buffervViewId());
else {
Client::bufferViewOverlay () —>removeView (dock->bufferviewId()) ;

}

When the window is minimized enable = false and isVisible() returns true. So removeView(dock->bufferViewld()). No View Ids, no notifications as far
as | understood (the Bufld presence is checked in MainWin::messageslinserted())

#3 - 09/08/2013 01:39 PM - Anonymous

This is probably a bug/regression in Qt; a minimized QWidget should not be reported as visible. | also note it works fine in Qt 5.

#4 - 09/08/2013 04:50 PM - enrico.tagliavini
I'm pretty new and confused by Qt but quiting from http:/gt-project.org/doc/qt-4.8/qwidget.html#visible-prop:

"A widget that happens to be obscured by other windows on the screen is considered to be visible. The same applies to iconified windows and
windows that exist on another virtual desktop (on platforms that support this concept).”

So a minimized window is considered visible. | also checked windowState() inside bufferViewToggled and the minimized status is added later. When |
minimize the window and the bufferViewToggled is called it seems that Qt sees the windows still not minimized. Can this be a bug / regression for
you?

"A widget receives spontaneous show and hide events when its mapping status is changed by the window system, e.g. a spontaneous hide event
when the user minimizes the window, and a spontaneous show event when the window is restored again."

So a minimized window can be invisible if the WM thinks this should be the case, am | understanding this correctly? But in KDE an iconified window is
kept visible since there are other means of displaying it, via Desktop effect for example. So | guess KWin never send an hide event to Quassel.

#5 - 09/08/2013 05:37 PM - Anonymous

There's a ton of ways to do things (multiple roots, one root and unmapping, compositing, ..). KWin may not unmap the window, but then it should set
_NET_WM_STATE_HIDDEN as per EWMH. Apparently Qt is stupid and does not regard that as hidden (see your first quote); | read the second
quote and figured it should Just Work™ because that's what Qt is for...

Oddly enough the documentation for Qt 5.1 is the same, so one of them is misbehaving (or the docs are wrong).

#6 - 09/21/2013 12:49 AM - aidenn

Hello,

| wanted to add that this issue is also present in the official 0.9.0 build on Windows 8.1 x64 (probably on W7 and W8 too) - no notification is sent when
the window is minimized, yet it works fine when it's not focused - tray icon flashing, sound, balloon, etc.

Cheers,
Aidenn

#7 - 12/23/2013 12:31 AM - Anonymous
- Status changed from New to Resolved

- % Done changed from 0 to 100

Applied in changeset quassellcommit:fd97519376748925efe765d138ad5af637d809bd.
